Index: issm/trunk/src/m/classes/rifts.py
===================================================================
--- issm/trunk/src/m/classes/rifts.py	(revision 13405)
+++ issm/trunk/src/m/classes/rifts.py	(revision 13975)
@@ -18,6 +18,6 @@
 	def __init__(self):
 		# {{{ Properties
-		self.riftstruct     = float('NaN')
-		self.riftproperties = float('NaN')
+		self.riftstruct     = []
+		self.riftproperties = []
 
 		#set defaults
@@ -53,8 +53,9 @@
 				#We have segments with rift markers, but no rift structure!
 				md.checkmessage("model should be processed for rifts (run meshprocessrifts)!")
-			md = checkfield(md,'rifts.riftstruct.fill','values',[WaterEnum(),AirEnum(),IceEnum(),MelangeEnum()])
+			for i,rift in enumerate(self.riftstruct):
+				md = checkfield(md,"rifts.riftstruct[%d]['fill']" % i,'values',[WaterEnum(),AirEnum(),IceEnum(),MelangeEnum()])
 		else:
-			if numpy.any(numpy.logical_not(isnans(self.riftstruct))):
-				md.checkmessage("riftstruct shoud be NaN since numrifts is 0!")
+			if self.riftstruct and numpy.any(numpy.logical_not(isnans(self.riftstruct))):
+				md.checkmessage("riftstruct should be NaN since numrifts is 0!")
 
 		return md
@@ -70,18 +71,18 @@
 
 		numpairs=0
-		for i in xrange(0,numrifts):
-			numpairs+=numpy.size(self.riftstruct[i].penaltypairs,0)
+		for rift in self.riftstruct:
+			numpairs+=numpy.size(rift['penaltypairs'],axis=0)
 
 		# 2 for nodes + 2 for elements+ 2 for  normals + 1 for length + 1 for fill + 1 for friction + 1 for fraction + 1 for fractionincrement + 1 for state.
 		data=numpy.zeros((numpairs,12))
 		count=0
-		for i in xrange(0,numrifts):
-			numpairsforthisrift=numpy.size(self.riftstruct[i]['penaltypairs'],0)
-			data[count:count+numpairsforthisrift-1,0:6]=self.riftstruct[i]['penaltypairs']
-			data[count:count+numpairsforthisrift-1,7]=self.riftstruct[i]['fill']
-			data[count:count+numpairsforthisrift-1,8]=self.riftstruct[i]['friction']
-			data[count:count+numpairsforthisrift-1,9]=self.riftstruct[i]['fraction']
-			data[count:count+numpairsforthisrift-1,10]=self.riftstruct[i]['fractionincrement']
-			data[count:count+numpairsforthisrift-1,11]=self.riftstruct[i]['state']
+		for rift in self.riftstruct:
+			numpairsforthisrift=numpy.size(rift['penaltypairs'],0)
+			data[count:count+numpairsforthisrift,0:7]=rift['penaltypairs']
+			data[count:count+numpairsforthisrift,7]=rift['fill']
+			data[count:count+numpairsforthisrift,8]=rift['friction']
+			data[count:count+numpairsforthisrift,9]=rift['fraction']
+			data[count:count+numpairsforthisrift,10]=rift['fractionincrement']
+			data[count:count+numpairsforthisrift,11]=rift['state'].reshape(-1)
 			count+=numpairsforthisrift
 
Index: issm/trunk/src/m/classes/solver.m
===================================================================
--- issm/trunk/src/m/classes/solver.m	(revision 13405)
+++ issm/trunk/src/m/classes/solver.m	(revision 13975)
@@ -98,5 +98,5 @@
 					 else
 						 %option with value. value can be string or scalar
-						 if isscalar(optionvalue),
+						 if isnumeric(optionvalue),
 							 fprintf(fid,'-%s %g\n',optionname,optionvalue);
 						 elseif ischar(optionvalue),
Index: issm/trunk/src/m/classes/surfaceforcings.m
===================================================================
--- issm/trunk/src/m/classes/surfaceforcings.m	(revision 13405)
+++ issm/trunk/src/m/classes/surfaceforcings.m	(revision 13975)
@@ -12,4 +12,6 @@
 		isdelta18o = 0;
 		hc = NaN;
+		href = NaN;
+		smbref = NaN;
 		smb_pos_max = NaN;
 		smb_pos_min = NaN;
@@ -35,5 +37,5 @@
 		end % }}}
 		function obj = setdefaultparameters(obj) % {{{
-		  
+
 		  %pdd method not used in default mode
 		  obj.ispdd=0;
@@ -60,4 +62,6 @@
 				elseif(obj.issmbgradients)
 					md = checkfield(md,'surfaceforcings.hc','forcing',1,'NaN',1);
+					md = checkfield(md,'surfaceforcings.href','forcing',1,'NaN',1);
+					md = checkfield(md,'surfaceforcings.smbref','forcing',1,'NaN',1);
 					md = checkfield(md,'surfaceforcings.smb_pos_max','forcing',1,'NaN',1);
 					md = checkfield(md,'surfaceforcings.smb_pos_min','forcing',1,'NaN',1);
@@ -89,4 +93,6 @@
 			fielddisplay(obj,'issmbgradients','is smb gradients method activated (0 or 1, default is 0)');
 			fielddisplay(obj,'hc',' elevation of intersection between accumulation and ablation regime required if smb gradients is activated');
+			fielddisplay(obj,'href',' reference elevation from which deviation is used to calculate SMB adjustment in smb gradients method');
+			fielddisplay(obj,'smbref',' reference smb from which deviation is calculated in smb gradients method');
 			fielddisplay(obj,'smb_pos_max',' maximum value of positive smb required if smb gradients is activated');
 			fielddisplay(obj,'smb_pos_min',' minimum value of positive smb required if smb gradients is activated');
@@ -117,4 +123,6 @@
 			if obj.issmbgradients,
 				WriteData(fid,'object',obj,'fieldname','hc','format','DoubleMat','mattype',1);
+				WriteData(fid,'object',obj,'fieldname','href','format','DoubleMat','mattype',1);
+				WriteData(fid,'object',obj,'fieldname','smbref','format','DoubleMat','mattype',1);
 				WriteData(fid,'object',obj,'fieldname','smb_pos_max','format','DoubleMat','mattype',1);
 				WriteData(fid,'object',obj,'fieldname','smb_pos_min','format','DoubleMat','mattype',1);
Index: issm/trunk/src/m/classes/surfaceforcings.py
===================================================================
--- issm/trunk/src/m/classes/surfaceforcings.py	(revision 13405)
+++ issm/trunk/src/m/classes/surfaceforcings.py	(revision 13975)
@@ -22,4 +22,6 @@
 		self.isdelta18o = 0
 		self.hc = float('NaN')
+		self.href = float('NaN')
+		self.smbref = float('NaN')
 		self.smb_pos_max = float('NaN')
 		self.smb_pos_min = float('NaN')
@@ -56,4 +58,6 @@
 		string="%s\n%s"%(string,fielddisplay(self,'issmbgradients','is smb gradients method activated (0 or 1, default is 0)'))
 		string="%s\n%s"%(string,fielddisplay(self,'hc',' elevation of intersection between accumulation and ablation regime required if smb gradients is activated'))
+		string="%s\n%s"%(string,fielddisplay(self,'href',' reference elevation from which deviation is used to calculate SMB adjustment in smb gradients method'))
+		string="%s\n%s"%(string,fielddisplay(self,'smbref',' reference smb from which deviation is calculated in smb gradients method'))
 		string="%s\n%s"%(string,fielddisplay(self,'smb_pos_max',' maximum value of positive smb required if smb gradients is activated'))
 		string="%s\n%s"%(string,fielddisplay(self,'smb_pos_min',' minimum value of positive smb required if smb gradients is activated'))
@@ -94,4 +98,6 @@
 			elif self.issmbgradients:
 				md = checkfield(md,'surfaceforcings.hc','forcing',1,'NaN',1)
+				md = checkfield(md,'surfaceforcings.href','forcing',1,'NaN',1)
+				md = checkfield(md,'surfaceforcings.smbref','forcing',1,'NaN',1)
 				md = checkfield(md,'surfaceforcings.smb_pos_max','forcing',1,'NaN',1)
 				md = checkfield(md,'surfaceforcings.smb_pos_min','forcing',1,'NaN',1)
@@ -130,4 +136,6 @@
 		if self.issmbgradients:
 			WriteData(fid,'object',self,'fieldname','hc','format','DoubleMat','mattype',1)
+			WriteData(fid,'object',self,'fieldname','href','format','DoubleMat','mattype',1)
+			WriteData(fid,'object',self,'fieldname','smbref','format','DoubleMat','mattype',1)
 			WriteData(fid,'object',self,'fieldname','smb_pos_max','format','DoubleMat','mattype',1)
 			WriteData(fid,'object',self,'fieldname','smb_pos_min','format','DoubleMat','mattype',1)
Index: issm/trunk/src/m/classes/thermal.m
===================================================================
--- issm/trunk/src/m/classes/thermal.m	(revision 13405)
+++ issm/trunk/src/m/classes/thermal.m	(revision 13975)
@@ -47,6 +47,8 @@
 			md = checkfield(md,'thermal.stabilization','numel',[1],'values',[0 1 2]);
 			md = checkfield(md,'thermal.spctemperature','forcing',1);
-			if (ismember(EnthalpyAnalysisEnum(),analyses) & md.thermal.isenthalpy & md.mesh.dimension==3),
-				md = checkfield(md,'thermal.spctemperature','<',md.materials.meltingpoint-md.materials.beta*md.materials.rho_ice*md.constants.g*(md.geometry.surface-md.mesh.z),'message','spctemperature should be below the adjusted melting point');
+			if (ismember(EnthalpyAnalysisEnum(),analyses) & (md.thermal.isenthalpy | solution==EnthalpySolutionEnum()) & md.mesh.dimension==3),
+				pos=find(md.thermal.spctemperature(1:md.mesh.numberofvertices,:)~=NaN);
+				replicate=repmat(md.geometry.surface-md.mesh.z,1,size(md.thermal.spctemperature,2));
+				md = checkfield(md,'thermal.spctemperature(find(md.thermal.spctemperature(1:md.mesh.numberofvertices,:)~=NaN))','<',md.materials.meltingpoint-md.materials.beta*md.materials.rho_ice*md.constants.g*replicate(pos),'message','spctemperature should be below the adjusted melting point');
 				md = checkfield(md,'thermal.isenthalpy','numel',[1],'values',[0 1]);
 			end
Index: issm/trunk/src/m/classes/thermal.py
===================================================================
--- issm/trunk/src/m/classes/thermal.py	(revision 13405)
+++ issm/trunk/src/m/classes/thermal.py	(revision 13975)
@@ -1,3 +1,4 @@
 #module imports
+import numpy
 from fielddisplay import fielddisplay
 from EnumDefinitions import *
@@ -69,6 +70,8 @@
 		md = checkfield(md,'thermal.stabilization','numel',[1],'values',[0,1,2])
 		md = checkfield(md,'thermal.spctemperature','forcing',1)
-		if EnthalpyAnalysisEnum() in analyses and md.thermal.isenthalpy and md.mesh.dimension==3:
-			md = checkfield(md,'thermal.spctemperature','<',md.materials.meltingpoint-md.materials.beta*md.materials.rho_ice*md.constants.g*(md.geometry.surface-md.mesh.z),'message',"spctemperature should be below the adjusted melting point")
+		if EnthalpyAnalysisEnum() in analyses and (md.thermal.isenthalpy or solution==EnthalpySolutionEnum()) and md.mesh.dimension==3:
+			pos=numpy.nonzero(numpy.logical_not(numpy.isnan(md.thermal.spctemperature[0:md.mesh.numberofvertices])))
+			replicate=numpy.tile(md.geometry.surface-md.mesh.z,(1,numpy.size(md.thermal.spctemperature,axis=1)))
+			md = checkfield(md,'thermal.spctemperature[numpy.nonzero(numpy.logical_not(numpy.isnan(md.thermal.spctemperature[0:md.mesh.numberofvertices,:])))]','<',md.materials.meltingpoint-md.materials.beta*md.materials.rho_ice*md.constants.g*replicate[pos],'message',"spctemperature should be below the adjusted melting point")
 			md = checkfield(md,'thermal.isenthalpy','numel',[1],'values',[0,1])
 
Index: issm/trunk/src/m/classes/verbose.m
===================================================================
--- issm/trunk/src/m/classes/verbose.m	(revision 13405)
+++ issm/trunk/src/m/classes/verbose.m	(revision 13975)
@@ -9,4 +9,5 @@
 %      control     : control method
 %      qmu         : sensitivity analysis
+%      autodiff    : AD analysis
 %
 %   Usage:
@@ -23,11 +24,12 @@
 		% {{{
 		%BEGINFIELDS
-		mprocessor  = false;
-		module      = false;
-		solution    = false;
-		solver      = false;
-		convergence = false;
-		control     = false;
-		qmu         = false;
+		mprocessor=false;
+		module=false;
+		solution=false;
+		solver=false;
+		convergence=false;
+		control=false;
+		qmu=false;
+		autodiff=false;
 		%ENDFIELDS
 		% }}}
@@ -83,4 +85,5 @@
 		if (verbose.control), binary=bitor(binary,32); end
 		if (verbose.qmu), binary=bitor(binary,64); end
+		if (verbose.autodiff), binary=bitor(binary,128); end
 		%ENDVERB2BIN
 
@@ -90,11 +93,12 @@
 
 		%BEGINBIN2VERB
-		verbose.mprocessor =logical(bitand(binary, 1));
-		verbose.module     =logical(bitand(binary, 2));
-		verbose.solution   =logical(bitand(binary, 4));
-		verbose.solver     =logical(bitand(binary, 8));
-		verbose.convergence=logical(bitand(binary,16));
-		verbose.control    =logical(bitand(binary,32));
-		verbose.qmu        =logical(bitand(binary,64));
+		if bitand(binary,1), verbose.mprocessor=true; else verbose.mprocessor=false; end
+		if bitand(binary,2), verbose.module=true; else verbose.module=false; end
+		if bitand(binary,4), verbose.solution=true; else verbose.solution=false; end
+		if bitand(binary,8), verbose.solver=true; else verbose.solver=false; end
+		if bitand(binary,16), verbose.convergence=true; else verbose.convergence=false; end
+		if bitand(binary,32), verbose.control=true; else verbose.control=false; end
+		if bitand(binary,64), verbose.qmu=true; else verbose.qmu=false; end
+		if bitand(binary,128), verbose.autodiff=true; else verbose.autodiff=false; end
 		%ENDBIN2VERB
 
@@ -105,5 +109,5 @@
 		end % }}}
 		function disp(verbose) % {{{
-			
+
 		%BEGINDISP
 		disp(sprintf('class ''%s''  = ',class(verbose)));
@@ -115,4 +119,5 @@
 		disp(sprintf('   %15s : %s','control',mat2str(verbose.control)));
 		disp(sprintf('   %15s : %s','qmu',mat2str(verbose.qmu)));
+		disp(sprintf('   %15s : %s','autodiff',mat2str(verbose.autodiff)));
 		%ENDDISP
 
Index: issm/trunk/src/m/classes/verbose.py
===================================================================
--- issm/trunk/src/m/classes/verbose.py	(revision 13405)
+++ issm/trunk/src/m/classes/verbose.py	(revision 13975)
@@ -16,4 +16,5 @@
 	      control     : control method
 	      qmu         : sensitivity analysis
+	      autodiff    : AD analysis
 
 	   Usage:
@@ -36,4 +37,5 @@
 		self.control     = False
 		self.qmu         = False
+		self.autodiff    = False
 		#ENDFIELDS
 
@@ -61,9 +63,26 @@
 			#Cast to logicals
 			listproperties=vars(self)
-			for [fieldname,fieldvalue] in listproperties.iteritems():
+			for fieldname,fieldvalue in listproperties.iteritems():
 				if isinstance(fieldvalue,bool) or isinstance(fieldvalue,(int,long,float)):
 					setattr(self,fieldname,bool(fieldvalue))
 				else:
 					raise TypeError("verbose supported field values are logicals only (True or False)")
+	# }}}
+
+	def __repr__(self):    # {{{
+			
+		#BEGINDISP
+		s ="class '%s'  = \n" % type(self)
+		s+="   %15s : %s\n" % ('mprocessor',self.mprocessor)
+		s+="   %15s : %s\n" % ('module',self.module)
+		s+="   %15s : %s\n" % ('solution',self.solution)
+		s+="   %15s : %s\n" % ('solver',self.solver)
+		s+="   %15s : %s\n" % ('convergence',self.convergence)
+		s+="   %15s : %s\n" % ('control',self.control)
+		s+="   %15s : %s\n" % ('qmu',self.qmu)
+		s+="   %15s : %s\n" % ('autodiff',self.autodiff)
+		#ENDDISP
+
+		return s
 	# }}}
 
@@ -86,4 +105,6 @@
 		if self.qmu:
 			binary=binary | 64
+		if self.autodiff:
+			binary=binary | 128
 		#ENDVERB2BIN
 
@@ -94,11 +115,12 @@
 
 		#BEGINBIN2VERB
-		self.mprocessor =bool(binary &  1)
-		self.module     =bool(binary &  2)
-		self.solution   =bool(binary &  4)
-		self.solver     =bool(binary &  8)
-		self.convergence=bool(binary & 16)
-		self.control    =bool(binary & 32)
-		self.qmu        =bool(binary & 64)
+		self.mprocessor =bool(binary &   1)
+		self.module     =bool(binary &   2)
+		self.solution   =bool(binary &   4)
+		self.solver     =bool(binary &   8)
+		self.convergence=bool(binary &  16)
+		self.control    =bool(binary &  32)
+		self.qmu        =bool(binary &  64)
+		self.autodiff   =bool(binary & 128)
 		#ENDBIN2VERB
 	# }}}
@@ -108,22 +130,6 @@
 	# }}}
 
-	def __repr__(self):    # {{{
-			
-		#BEGINDISP
-		s ="class '%s'  = \n" % type(self)
-		s+="   %15s : %s\n" % ('mprocessor',self.mprocessor)
-		s+="   %15s : %s\n" % ('module',self.module)
-		s+="   %15s : %s\n" % ('solution',self.solution)
-		s+="   %15s : %s\n" % ('solver',self.solver)
-		s+="   %15s : %s\n" % ('convergence',self.convergence)
-		s+="   %15s : %s\n" % ('control',self.control)
-		s+="   %15s : %s\n" % ('qmu',self.qmu)
-		#ENDDISP
-
-		return s
+	def marshall(self,fid):    # {{{
+		WriteData(fid,'data',self.VerboseToBinary(),'enum',VerboseEnum(),'format','Integer')
 	# }}}
 
-	def marshall(self,fid):    # {{{
-			WriteData(fid,'data',self.VerboseToBinary(),'enum',VerboseEnum(),'format','Integer')
-	# }}}
-
Index: issm/trunk/src/m/consistency/ismodelselfconsistent.m
===================================================================
--- issm/trunk/src/m/consistency/ismodelselfconsistent.m	(revision 13405)
+++ issm/trunk/src/m/consistency/ismodelselfconsistent.m	(revision 13975)
@@ -28,9 +28,5 @@
 
 	%Check consistency of the object
-	if verLessThan('matlab', '7.6')
-		md=checkconsistency(md.(field),md,solution,analyses);
-	else
-		md=md.(field).checkconsistency(md,solution,analyses);
-	end
+	md=checkconsistency(md.(field),md,solution,analyses);
 end
 
@@ -46,6 +42,4 @@
 %   Usage:
 %      [analyses, numanalyses]=AnalysisConfiguration(solutiontype);
-
-
 
 switch solutiontype,
Index: issm/trunk/src/m/contrib/bamg/meshread.m
===================================================================
--- issm/trunk/src/m/contrib/bamg/meshread.m	(revision 13405)
+++ issm/trunk/src/m/contrib/bamg/meshread.m	(revision 13975)
@@ -1,3 +1,3 @@
-function Struct=meshread(filename);
+function Struct=meshread(filename)
 
 %some checks
Index: issm/trunk/src/m/contrib/bamg/yams.m
===================================================================
--- issm/trunk/src/m/contrib/bamg/yams.m	(revision 13405)
+++ issm/trunk/src/m/contrib/bamg/yams.m	(revision 13975)
@@ -1,3 +1,3 @@
-function md=yams(md,varargin);
+function md=yams(md,varargin)
 %MESHYAMS - Build model of Antarctica by refining according to observed velocity error estimator
 %
@@ -102,5 +102,5 @@
 
 end
-	
+
 disp(['Final mesh, number of elements: ' num2str(md.mesh.numberofelements)]);
 
Index: issm/trunk/src/m/contrib/gslib/gamv.m
===================================================================
--- issm/trunk/src/m/contrib/gslib/gamv.m	(revision 13405)
+++ issm/trunk/src/m/contrib/gslib/gamv.m	(revision 13975)
@@ -1,3 +1,3 @@
-function output = gamv(x,y,data,varargin);
+function output = gamv(x,y,data,varargin)
 %GAMV - use gslib for Kriging
 %
Index: issm/trunk/src/m/contrib/gslib/gslib.m
===================================================================
--- issm/trunk/src/m/contrib/gslib/gslib.m	(revision 13405)
+++ issm/trunk/src/m/contrib/gslib/gslib.m	(revision 13975)
@@ -1,3 +1,3 @@
-function output = gslib(x,y,data,varargin);
+function output = gslib(x,y,data,varargin)
 %GSLIB - use gslib for Kriging
 %
Index: issm/trunk/src/m/contrib/gslib/pkriging.m
===================================================================
--- issm/trunk/src/m/contrib/gslib/pkriging.m	(revision 13405)
+++ issm/trunk/src/m/contrib/gslib/pkriging.m	(revision 13975)
@@ -1,3 +1,3 @@
-function [B E]=pkriging(x,y,observations,x_interp,y_interp,varargin);
+function [B E]=pkriging(x,y,observations,x_interp,y_interp,varargin)
 %PKRIGING - parallel Kriging
 %
Index: issm/trunk/src/m/contrib/gslib/varmap.m
===================================================================
--- issm/trunk/src/m/contrib/gslib/varmap.m	(revision 13405)
+++ issm/trunk/src/m/contrib/gslib/varmap.m	(revision 13975)
@@ -1,3 +1,3 @@
-function output = varmap(x,y,data,varargin);
+function output = varmap(x,y,data,varargin)
 %VARMAP - use gslib for Kriging
 %
Index: issm/trunk/src/m/contrib/hack/tres.m
===================================================================
--- issm/trunk/src/m/contrib/hack/tres.m	(revision 13405)
+++ issm/trunk/src/m/contrib/hack/tres.m	(revision 13975)
@@ -22,13 +22,7 @@
 		md.initialization.pressure=md.results.DiagnosticSolution.Pressure;
 	end
-	if md.rifts.numrifts,
+	if ~isempty(md.rifts.riftstruct),
 		if isfield(md.results.DiagnosticSolution,'riftproperties'),
 			md.rifts.riftproperties=md.results.DiagnosticSolution.riftproperties;
-		end
-	end
-	if md.inversion.iscontrol==1,
-		for control_parameters=md.inversion.control_parameters
-			%Will need to be updated... good luck ;)
-			md.(EnumToModelField(control_parameters))=md.results.DiagnosticSolution.(EnumToString(control_parameters));
 		end
 	end
Index: issm/trunk/src/m/contrib/massbalance/outflow.m
===================================================================
--- issm/trunk/src/m/contrib/massbalance/outflow.m	(revision 13405)
+++ issm/trunk/src/m/contrib/massbalance/outflow.m	(revision 13975)
@@ -1,3 +1,3 @@
-function flag=outflow(md);
+function flag=outflow(md)
 %OUTFLOW - flag nodes on outflux boundary
 %
Index: issm/trunk/src/m/enum/EnumDefinitions.py
===================================================================
--- issm/trunk/src/m/enum/EnumDefinitions.py	(revision 13405)
+++ issm/trunk/src/m/enum/EnumDefinitions.py	(revision 13975)
@@ -19,14 +19,4 @@
 	return StringToEnum('AutodiffIsautodiff')[0]
 
-def AutodiffDependentsEnum():
-	"""
-	AUTODIFFDEPENDENTSENUM - Enum of AutodiffDependents
-
-	   Usage:
-	      macro=AutodiffDependentsEnum()
-	"""
-
-	return StringToEnum('AutodiffDependents')[0]
-
 def AutodiffNumDependentsEnum():
 	"""
@@ -39,13 +29,53 @@
 	return StringToEnum('AutodiffNumDependents')[0]
 
-def AutodiffIndependentsEnum():
-	"""
-	AUTODIFFINDEPENDENTSENUM - Enum of AutodiffIndependents
-
-	   Usage:
-	      macro=AutodiffIndependentsEnum()
-	"""
-
-	return StringToEnum('AutodiffIndependents')[0]
+def AutodiffNumDependentObjectsEnum():
+	"""
+	AUTODIFFNUMDEPENDENTOBJECTSENUM - Enum of AutodiffNumDependentObjects
+
+	   Usage:
+	      macro=AutodiffNumDependentObjectsEnum()
+	"""
+
+	return StringToEnum('AutodiffNumDependentObjects')[0]
+
+def AutodiffDependentObjectNamesEnum():
+	"""
+	AUTODIFFDEPENDENTOBJECTNAMESENUM - Enum of AutodiffDependentObjectNames
+
+	   Usage:
+	      macro=AutodiffDependentObjectNamesEnum()
+	"""
+
+	return StringToEnum('AutodiffDependentObjectNames')[0]
+
+def AutodiffDependentObjectTypesEnum():
+	"""
+	AUTODIFFDEPENDENTOBJECTTYPESENUM - Enum of AutodiffDependentObjectTypes
+
+	   Usage:
+	      macro=AutodiffDependentObjectTypesEnum()
+	"""
+
+	return StringToEnum('AutodiffDependentObjectTypes')[0]
+
+def AutodiffDependentObjectIndicesEnum():
+	"""
+	AUTODIFFDEPENDENTOBJECTINDICESENUM - Enum of AutodiffDependentObjectIndices
+
+	   Usage:
+	      macro=AutodiffDependentObjectIndicesEnum()
+	"""
+
+	return StringToEnum('AutodiffDependentObjectIndices')[0]
+
+def AutodiffDependentObjectsEnum():
+	"""
+	AUTODIFFDEPENDENTOBJECTSENUM - Enum of AutodiffDependentObjects
+
+	   Usage:
+	      macro=AutodiffDependentObjectsEnum()
+	"""
+
+	return StringToEnum('AutodiffDependentObjects')[0]
 
 def AutodiffNumIndependentsEnum():
@@ -59,4 +89,44 @@
 	return StringToEnum('AutodiffNumIndependents')[0]
 
+def AutodiffNumIndependentObjectsEnum():
+	"""
+	AUTODIFFNUMINDEPENDENTOBJECTSENUM - Enum of AutodiffNumIndependentObjects
+
+	   Usage:
+	      macro=AutodiffNumIndependentObjectsEnum()
+	"""
+
+	return StringToEnum('AutodiffNumIndependentObjects')[0]
+
+def AutodiffIndependentObjectNamesEnum():
+	"""
+	AUTODIFFINDEPENDENTOBJECTNAMESENUM - Enum of AutodiffIndependentObjectNames
+
+	   Usage:
+	      macro=AutodiffIndependentObjectNamesEnum()
+	"""
+
+	return StringToEnum('AutodiffIndependentObjectNames')[0]
+
+def AutodiffIndependentObjectTypesEnum():
+	"""
+	AUTODIFFINDEPENDENTOBJECTTYPESENUM - Enum of AutodiffIndependentObjectTypes
+
+	   Usage:
+	      macro=AutodiffIndependentObjectTypesEnum()
+	"""
+
+	return StringToEnum('AutodiffIndependentObjectTypes')[0]
+
+def AutodiffIndependentObjectsEnum():
+	"""
+	AUTODIFFINDEPENDENTOBJECTSENUM - Enum of AutodiffIndependentObjects
+
+	   Usage:
+	      macro=AutodiffIndependentObjectsEnum()
+	"""
+
+	return StringToEnum('AutodiffIndependentObjects')[0]
+
 def AutodiffJacobianEnum():
 	"""
@@ -79,13 +149,63 @@
 	return StringToEnum('AutodiffXp')[0]
 
-def AutodiffFosForwardOutputEnum():
-	"""
-	AUTODIFFFOSFORWARDOUTPUTENUM - Enum of AutodiffFosForwardOutput
-
-	   Usage:
-	      macro=AutodiffFosForwardOutputEnum()
-	"""
-
-	return StringToEnum('AutodiffFosForwardOutput')[0]
+def AutodiffDriverEnum():
+	"""
+	AUTODIFFDRIVERENUM - Enum of AutodiffDriver
+
+	   Usage:
+	      macro=AutodiffDriverEnum()
+	"""
+
+	return StringToEnum('AutodiffDriver')[0]
+
+def AutodiffFosForwardIndexEnum():
+	"""
+	AUTODIFFFOSFORWARDINDEXENUM - Enum of AutodiffFosForwardIndex
+
+	   Usage:
+	      macro=AutodiffFosForwardIndexEnum()
+	"""
+
+	return StringToEnum('AutodiffFosForwardIndex')[0]
+
+def AutodiffFovForwardIndicesEnum():
+	"""
+	AUTODIFFFOVFORWARDINDICESENUM - Enum of AutodiffFovForwardIndices
+
+	   Usage:
+	      macro=AutodiffFovForwardIndicesEnum()
+	"""
+
+	return StringToEnum('AutodiffFovForwardIndices')[0]
+
+def AutodiffFosReverseIndexEnum():
+	"""
+	AUTODIFFFOSREVERSEINDEXENUM - Enum of AutodiffFosReverseIndex
+
+	   Usage:
+	      macro=AutodiffFosReverseIndexEnum()
+	"""
+
+	return StringToEnum('AutodiffFosReverseIndex')[0]
+
+def AutodiffMassFluxSegmentsPresentEnum():
+	"""
+	AUTODIFFMASSFLUXSEGMENTSPRESENTENUM - Enum of AutodiffMassFluxSegmentsPresent
+
+	   Usage:
+	      macro=AutodiffMassFluxSegmentsPresentEnum()
+	"""
+
+	return StringToEnum('AutodiffMassFluxSegmentsPresent')[0]
+
+def AutodiffKeepEnum():
+	"""
+	AUTODIFFKEEPENUM - Enum of AutodiffKeep
+
+	   Usage:
+	      macro=AutodiffKeepEnum()
+	"""
+
+	return StringToEnum('AutodiffKeep')[0]
 
 def BalancethicknessSpcthicknessEnum():
@@ -199,4 +319,14 @@
 	return StringToEnum('ConstantsYts')[0]
 
+def DependentObjectEnum():
+	"""
+	DEPENDENTOBJECTENUM - Enum of DependentObject
+
+	   Usage:
+	      macro=DependentObjectEnum()
+	"""
+
+	return StringToEnum('DependentObject')[0]
+
 def DiagnosticAbstolEnum():
 	"""
@@ -589,4 +719,14 @@
 	return StringToEnum('HydrologyStabilization')[0]
 
+def IndependentObjectEnum():
+	"""
+	INDEPENDENTOBJECTENUM - Enum of IndependentObject
+
+	   Usage:
+	      macro=IndependentObjectEnum()
+	"""
+
+	return StringToEnum('IndependentObject')[0]
+
 def InversionControlParametersEnum():
 	"""
@@ -1319,4 +1459,24 @@
 	return StringToEnum('PrognosticVertexPairing')[0]
 
+def PrognosticNumRequestedOutputsEnum():
+	"""
+	PROGNOSTICNUMREQUESTEDOUTPUTSENUM - Enum of PrognosticNumRequestedOutputs
+
+	   Usage:
+	      macro=PrognosticNumRequestedOutputsEnum()
+	"""
+
+	return StringToEnum('PrognosticNumRequestedOutputs')[0]
+
+def PrognosticRequestedOutputsEnum():
+	"""
+	PROGNOSTICREQUESTEDOUTPUTSENUM - Enum of PrognosticRequestedOutputs
+
+	   Usage:
+	      macro=PrognosticRequestedOutputsEnum()
+	"""
+
+	return StringToEnum('PrognosticRequestedOutputs')[0]
+
 def QmuIsdakotaEnum():
 	"""
@@ -1329,13 +1489,33 @@
 	return StringToEnum('QmuIsdakota')[0]
 
-def QmuMassFluxSegmentsEnum():
-	"""
-	QMUMASSFLUXSEGMENTSENUM - Enum of QmuMassFluxSegments
-
-	   Usage:
-	      macro=QmuMassFluxSegmentsEnum()
-	"""
-
-	return StringToEnum('QmuMassFluxSegments')[0]
+def MassFluxSegmentsEnum():
+	"""
+	MASSFLUXSEGMENTSENUM - Enum of MassFluxSegments
+
+	   Usage:
+	      macro=MassFluxSegmentsEnum()
+	"""
+
+	return StringToEnum('MassFluxSegments')[0]
+
+def MassFluxSegmentsPresentEnum():
+	"""
+	MASSFLUXSEGMENTSPRESENTENUM - Enum of MassFluxSegmentsPresent
+
+	   Usage:
+	      macro=MassFluxSegmentsPresentEnum()
+	"""
+
+	return StringToEnum('MassFluxSegmentsPresent')[0]
+
+def QmuMassFluxSegmentsPresentEnum():
+	"""
+	QMUMASSFLUXSEGMENTSPRESENTENUM - Enum of QmuMassFluxSegmentsPresent
+
+	   Usage:
+	      macro=QmuMassFluxSegmentsPresentEnum()
+	"""
+
+	return StringToEnum('QmuMassFluxSegmentsPresent')[0]
 
 def QmuNumberofpartitionsEnum():
@@ -1679,4 +1859,24 @@
 	return StringToEnum('SurfaceforcingsHc')[0]
 
+def SurfaceforcingsHrefEnum():
+	"""
+	SURFACEFORCINGSHREFENUM - Enum of SurfaceforcingsHref
+
+	   Usage:
+	      macro=SurfaceforcingsHrefEnum()
+	"""
+
+	return StringToEnum('SurfaceforcingsHref')[0]
+
+def SurfaceforcingsSmbrefEnum():
+	"""
+	SURFACEFORCINGSSMBREFENUM - Enum of SurfaceforcingsSmbref
+
+	   Usage:
+	      macro=SurfaceforcingsSmbrefEnum()
+	"""
+
+	return StringToEnum('SurfaceforcingsSmbref')[0]
+
 def SurfaceforcingsSmbPosMaxEnum():
 	"""
@@ -2539,4 +2739,14 @@
 	return StringToEnum('DoubleInput')[0]
 
+def DataSetParamEnum():
+	"""
+	DATASETPARAMENUM - Enum of DataSetParam
+
+	   Usage:
+	      macro=DataSetParamEnum()
+	"""
+
+	return StringToEnum('DataSetParam')[0]
+
 def DoubleMatArrayParamEnum():
 	"""
@@ -2829,4 +3039,14 @@
 	return StringToEnum('PentaP1Input')[0]
 
+def ProfilerEnum():
+	"""
+	PROFILERENUM - Enum of Profiler
+
+	   Usage:
+	      macro=ProfilerEnum()
+	"""
+
+	return StringToEnum('Profiler')[0]
+
 def MatrixParamEnum():
 	"""
@@ -4509,4 +4729,24 @@
 	return StringToEnum('OutputFilePointer')[0]
 
+def OutputFileNameEnum():
+	"""
+	OUTPUTFILENAMEENUM - Enum of OutputFileName
+
+	   Usage:
+	      macro=OutputFileNameEnum()
+	"""
+
+	return StringToEnum('OutputFileName')[0]
+
+def LockFileNameEnum():
+	"""
+	LOCKFILENAMEENUM - Enum of LockFileName
+
+	   Usage:
+	      macro=LockFileNameEnum()
+	"""
+
+	return StringToEnum('LockFileName')[0]
+
 def PetscOptionsAnalysesEnum():
 	"""
@@ -4757,4 +4997,4 @@
 	"""
 
-	return 474
-
+	return 498
+
Index: issm/trunk/src/m/enum/MaximumNumberOfEnums.m
===================================================================
--- issm/trunk/src/m/enum/MaximumNumberOfEnums.m	(revision 13405)
+++ issm/trunk/src/m/enum/MaximumNumberOfEnums.m	(revision 13975)
@@ -9,3 +9,3 @@
 %      macro=MaximumNumberOfEnums()
 
-macro=474;
+macro=498;
Index: issm/trunk/src/m/enum/OutputfilenameEnum.m
===================================================================
--- issm/trunk/src/m/enum/OutputfilenameEnum.m	(revision 13405)
+++ issm/trunk/src/m/enum/OutputfilenameEnum.m	(revision 13975)
@@ -1,4 +1,4 @@
-function macro=OutputfilenameEnum()
-%OUTPUTFILENAMEENUM - Enum of Outputfilename
+function macro=OutputFileNameEnum()
+%OUTPUTFILENAMEENUM - Enum of OutputFileName
 %
 %   WARNING: DO NOT MODIFY THIS FILE
@@ -7,5 +7,5 @@
 %
 %   Usage:
-%      macro=OutputfilenameEnum()
+%      macro=OutputFileNameEnum()
 
-macro=StringToEnum('Outputfilename');
+macro=StringToEnum('OutputFileName');
Index: issm/trunk/src/m/exp/expcoarsen.m
===================================================================
--- issm/trunk/src/m/exp/expcoarsen.m	(revision 13405)
+++ issm/trunk/src/m/exp/expcoarsen.m	(revision 13975)
@@ -1,3 +1,3 @@
-function expcoarsen(newfile,oldfile,resolution);
+function expcoarsen(newfile,oldfile,resolution)
 %EXPCOARSEN - coarsen an exp contour
 %
Index: issm/trunk/src/m/exp/expcreatecontour.m
===================================================================
--- issm/trunk/src/m/exp/expcreatecontour.m	(revision 13405)
+++ issm/trunk/src/m/exp/expcreatecontour.m	(revision 13975)
@@ -1,3 +1,3 @@
-function expcreatecontour(filename);
+function expcreatecontour(filename)
 %EXPCREATECONTOUR - create a contour from a list of points
 %
@@ -34,3 +34,2 @@
 %write contour using expwrite
 expwrite(a,filename);
-
Index: issm/trunk/src/m/exp/expcreateprofile.m
===================================================================
--- issm/trunk/src/m/exp/expcreateprofile.m	(revision 13405)
+++ issm/trunk/src/m/exp/expcreateprofile.m	(revision 13975)
@@ -1,3 +1,3 @@
-function expcreateprofile(filename);
+function expcreateprofile(filename)
 %EXPCREATEPROFILE - create an Argus file from a list of points
 %
Index: issm/trunk/src/m/exp/expread.m
===================================================================
--- issm/trunk/src/m/exp/expread.m	(revision 13405)
+++ issm/trunk/src/m/exp/expread.m	(revision 13975)
@@ -1,3 +1,3 @@
-function Struct=expread(filename);
+function Struct=expread(filename)
 %EXPREAD - read a file exp and build a Structure
 %
Index: issm/trunk/src/m/exp/expwrite.m
===================================================================
--- issm/trunk/src/m/exp/expwrite.m	(revision 13405)
+++ issm/trunk/src/m/exp/expwrite.m	(revision 13975)
@@ -1,3 +1,3 @@
-function expwrite(a,filename);
+function expwrite(a,filename)
 %EXPWRITE - write an Argus file from a structure given in input
 %
@@ -20,5 +20,5 @@
 		error('contours x and y coordinates must be of identical size');
 	end
-   
+
 	if isfield(a,'name'),
 		if ~isempty(a(n).name),
@@ -30,5 +30,5 @@
 		fprintf(fid,'%s\n','## Name:');
 	end
-   
+
 	fprintf(fid,'%s\n','## Icon:0');
 	fprintf(fid,'%s\n','# Points Count Value');
